---
title: Gamepad
slug: Web/API/Gamepad
tags:
  - API
  - Gamepad API
  - Games
  - Interface
  - Reference
---
<div>{{APIRef("Gamepad API")}}</div>

<p>The <strong><code>Gamepad</code></strong> interface of the <a href="/en-US/docs/Web/API/Gamepad_API">Gamepad API</a> defines an individual gamepad or other controller, allowing access to information such as button presses, axis positions, and id.</p>

<p>A Gamepad object can be returned in one of two ways: via the <code>gamepad</code> property of the {{event("gamepadconnected")}} and {{event("gamepaddisconnected")}} events, or by grabbing any position in the array returned by the {{domxref("Navigator.getGamepads()")}} method.</p>

<h2 id="Properties">Properties</h2>

<dl>
 <dt>{{domxref("Gamepad.axes")}} {{readonlyInline}}</dt>
 <dd>An array representing the controls with axes present on the device (e.g. analog thumb sticks).</dd>
 <dt>{{domxref("Gamepad.buttons")}} {{readonlyInline}}</dt>
 <dd>An array of {{domxref("gamepadButton")}} objects representing the buttons present on the device.</dd>
 <dt>{{domxref("Gamepad.connected")}} {{readonlyInline}}</dt>
 <dd>A boolean indicating whether the gamepad is still connected to the system.</dd>
 <dt>{{domxref("Gamepad.displayId")}} {{readonlyInline}}</dt>
 <dd><dfn>Returns the {{domxref("VRDisplay.displayId")}} of an associated {{domxref("VRDisplay")}} (if relevant) — the <code>VRDisplay</code> that the gamepad is controlling the displayed scene of.</dfn></dd>
 <dt>{{domxref("Gamepad.id")}} {{readonlyInline}}</dt>
 <dd>A {{domxref("DOMString")}} containing identifying information about the controller.</dd>
 <dt>{{domxref("Gamepad.index")}} {{readonlyInline}}</dt>
 <dd>An integer that is auto-incremented to be unique for each device currently connected to the system.</dd>
 <dt>{{domxref("Gamepad.mapping")}} {{readonlyInline}}</dt>
 <dd>A string indicating whether the browser has remapped the controls on the device to a known layout.</dd>
 <dt>{{domxref("Gamepad.timestamp")}} {{readonlyInline}}</dt>
 <dd>A {{domxref("DOMHighResTimeStamp")}} representing the last time the data for this gamepad was updated.</dd>
</dl>

<h3 id="Experimental_extensions_to_Gamepad">Experimental extensions to Gamepad</h3>

<p>The following interfaces are defined in the {{SpecName("GamepadExtensions")}} specification, and provide access to experimental features like haptic feedback and WebVR controller pose information.</p>

<dl>
 <dt>{{domxref("Gamepad.hand")}} {{readonlyInline}}</dt>
 <dd>An enum defining what hand the controller is being held in, or is most likely to be held in.</dd>
 <dt>{{domxref("Gamepad.hapticActuators")}} {{readonlyInline}}</dt>
 <dd>An array containing {{domxref("GamepadHapticActuator")}} objects, each of which represents haptic feedback hardware available on the controller.</dd>
 <dt>{{domxref("Gamepad.pose")}} {{readonlyInline}}</dt>
 <dd>A {{domxref("GamepadPose")}} object representing the pose information associated with a WebVR controller (e.g. its position and orientation in 3D space).</dd>
</dl>

<h2 id="Example">Example</h2>

<pre class="brush: js">window.addEventListener("gamepadconnected", function(e) {
  console.log("Gamepad connected at index %d: %s. %d buttons, %d axes.",
  e.gamepad.index, e.gamepad.id,
  e.gamepad.buttons.length, e.gamepad.axes.length);
});</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("Gamepad", "#gamepad-interface", "Gamepad")}}</td>
   <td>{{Spec2("Gamepad")}}</td>
   <td>Initial definition</td>
  </tr>
  <tr>
   <td>{{SpecName('WebVR 1.1', '#gamepad-getvrdisplays-attribute', 'displayId')}}</td>
   <td>{{Spec2("WebVR 1.1")}}</td>
   <td>Defines the {{domxref("Gamepad.displayId")}} property.</td>
  </tr>
  <tr>
   <td>{{SpecName("GamepadExtensions", "#partial-gamepad-interface", "Gamepad extensions")}}</td>
   <td>{{Spec2("GamepadExtensions")}}</td>
   <td>Defines the {{anch("Experimental extensions to Gamepad")}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Gamepad")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/Guide/API/Gamepad">Using the Gamepad API</a></li>
 <li><a href="/en-US/docs/Web/API/Gamepad_API">Gamepad API</a></li>
</ul>
